import { ResultStatus } from "./result-status";
export declare class Result<T> {
    readonly errorMessage: string | null;
    readonly error: Error | null;
    readonly hasError: boolean;
    readonly isConflict: boolean;
    readonly isFailure: boolean;
    readonly isForbidden: boolean;
    readonly isInvalid: boolean;
    readonly isNotFound: boolean;
    readonly isSuccess: boolean;
    readonly isUnauthorized: boolean;
    readonly isUnsupported: boolean;
    readonly metaData: {
        [key: string]: unknown;
    } | null;
    readonly status: ResultStatus;
    readonly value: T | null;
    private constructor();
    static conflict<T>(errorMessage?: string, error?: Error, metaData?: {
        [key: string]: unknown;
    }): Result<T>;
    static failure<T>(errorMessage?: string, error?: Error, metaData?: {
        [key: string]: unknown;
    }): Result<T>;
    static forbidden<T>(errorMessage?: string, error?: Error, metaData?: {
        [key: string]: unknown;
    }): Result<T>;
    static invalid<T>(errorMessage?: string, error?: Error, metaData?: {
        [key: string]: unknown;
    }): Result<T>;
    static notFound<T>(errorMessage?: string, error?: Error, metaData?: {
        [key: string]: unknown;
    }): Result<T>;
    static success<T>(value: T): Result<T>;
    static unauthorized<T>(errorMessage?: string, error?: Error, metaData?: {
        [key: string]: unknown;
    }): Result<T>;
    static unsupported<T>(errorMessage?: string, error?: Error, metaData?: {
        [key: string]: unknown;
    }): Result<T>;
    addOrUpdateMetadata(key: string, value: unknown): Result<T>;
    map<TResult>(mapper: (value: T | null) => TResult): Result<TResult>;
    recover(recovery: (value: T | null) => Result<T>): Result<T>;
    match<TResult>(success: (value: T) => TResult, failure: (errorMessage: string | null, error: Error | null, metaData: Record<string, unknown> | null) => TResult): TResult;
    unwrapOrNull(): T | null;
    unwrapOrDefault(defaultValue: T | unknown): T | unknown;
    unwrap(): T;
    unwrapOrThrow(errorProvider: () => Error): T;
}
//# sourceMappingURL=result.d.ts.map