"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isRegExp = exports.isReadonlyArray = exports.isPromiseOfT = exports.isPromise = exports.isPlainObject = exports.isObjectLike = exports.isObjectEmpty = exports.isObject = exports.isNumeric = exports.isNumberArray = exports.isNumber = exports.isNull = exports.isNil = exports.isNative = exports.isNaN = exports.isMatchWith = exports.isMatch = exports.isMap = exports.isLiteral = exports.isLength = exports.isIterable = exports.isInteger = exports.isFunction = exports.isFinite = exports.isExactUnion = exports.isError = exports.isEqualWith = exports.isEqual = exports.isEmptyObject = exports.isEmpty = exports.isElement = exports.isDate = exports.isBuffer = exports.isBoolean = exports.isBigInt = exports.isArrayLikeObject = exports.isArrayLike = exports.isArrayBuffer = exports.isArray = exports.isArguments = exports.hasSameType = exports.gte = exports.gt = exports.eq = exports.conformsTo = exports.cloneWith = exports.cloneDeepWith = exports.cloneDeep = exports.clone = exports.castArray = void 0;
exports.type = exports.toString = exports.toSafeInteger = exports.toPlainObject = exports.toNumber = exports.toInteger = exports.toFinite = exports.toArray = exports.safeStringify = exports.lte = exports.lt = exports.isWindow = exports.isWeakSet = exports.isWeakMap = exports.isUnion = exports.isUndefined = exports.isTypedArray = exports.isSymbol = exports.isStringArray = exports.isString = exports.isSet = exports.isSafeInteger = void 0;
// Creates an array of elements with `value` as the single element if `value` is not already an array
function castArray(value) {
    return Array.isArray(value) ? value : [value];
}
exports.castArray = castArray;
// Creates a shallow clone of `value`
function clone(value) {
    return Object.assign({}, value);
}
exports.clone = clone;
// Creates a deep clone of `value` using JSON serialization
function cloneDeep(value) {
    return JSON.parse(JSON.stringify(value));
}
exports.cloneDeep = cloneDeep;
// Creates a deep clone of `value` using a customizer function
function cloneDeepWith(value, customizer) {
    var cloned = cloneDeep(value);
    return customizer(cloned);
}
exports.cloneDeepWith = cloneDeepWith;
// Creates a shallow clone of `value` using a customizer function
function cloneWith(value, customizer) {
    var cloned = clone(value);
    return customizer(cloned);
}
exports.cloneWith = cloneWith;
// Checks if `object` conforms to the provided properties and values
function conformsTo(object, source) {
    for (var key in source) {
        var predicate = source[key];
        if (!predicate(object[key])) {
            return false;
        }
    }
    return true;
}
exports.conformsTo = conformsTo;
// Performs a loose equality comparison between two values
function eq(value, other) {
    return value === other || (value !== value && other !== other);
}
exports.eq = eq;
// Checks if `value` is greater than `other`
function gt(value, other) {
    return value > other;
}
exports.gt = gt;
// Checks if `value` is greater than or equal to `other`
function gte(value, other) {
    return value >= other;
}
exports.gte = gte;
// Checks if `value` is an arguments object
function isArguments(value) {
    return Object.prototype.toString.call(value) === "[object Arguments]";
}
exports.isArguments = isArguments;
// Checks if `value` is an array
function isArray(value) {
    return Array.isArray(value);
}
exports.isArray = isArray;
// Checks if `value` is an ArrayBuffer
function isArrayBuffer(value) {
    return value instanceof ArrayBuffer;
}
exports.isArrayBuffer = isArrayBuffer;
// Checks if `value` is array-like (has a length property)
function isArrayLike(value) {
    return (value != null &&
        typeof value.length === "number");
}
exports.isArrayLike = isArrayLike;
// Checks if `value` is an array-like object
function isArrayLikeObject(value) {
    return isArrayLike(value) && typeof value === "object";
}
exports.isArrayLikeObject = isArrayLikeObject;
// Checks if `value` is a boolean
function isBoolean(value) {
    return typeof value === "boolean";
}
exports.isBoolean = isBoolean;
// Checks if `value` is a Buffer
function isBuffer(value) {
    return Buffer.isBuffer(value);
}
exports.isBuffer = isBuffer;
// Checks if `value` is a DOM element
function isElement(value) {
    return value instanceof Element;
}
exports.isElement = isElement;
// Checks if `value` is an empty value (empty array, object, string, or null/undefined)
function isEmpty(value) {
    if (value == null) {
        return true;
    }
    if (isArrayLike(value) || typeof value === "string") {
        return value.length === 0;
    }
    if (typeof value === "object") {
        return Object.keys(value).length === 0;
    }
    return false;
}
exports.isEmpty = isEmpty;
// Performs a deep comparison between two values to determine if they are equivalent
function isEqual(value, other) {
    return (value === other || isEqualWith(value, other, defaultIsEqualCustomizer));
    function defaultIsEqualCustomizer(value, other) {
        var e_1, _a;
        if (typeof value !== typeof other) {
            return false;
        }
        if (typeof value !== "object" || value === null || other === null) {
            return value === other;
        }
        if (Array.isArray(value) !== Array.isArray(other)) {
            return false;
        }
        if (Array.isArray(value)) {
            var valueArray = value;
            var otherArray = other;
            if (valueArray.length !== otherArray.length) {
                return false;
            }
            for (var i = 0; i < valueArray.length; i++) {
                if (!defaultIsEqualCustomizer(valueArray[i], otherArray[i])) {
                    return false;
                }
            }
            return true;
        }
        var valueObj = value;
        var otherObj = other;
        var keysA = Object.keys(valueObj);
        var keysB = Object.keys(otherObj);
        if (keysA.length !== keysB.length) {
            return false;
        }
        try {
            for (var keysA_1 = __values(keysA), keysA_1_1 = keysA_1.next(); !keysA_1_1.done; keysA_1_1 = keysA_1.next()) {
                var key = keysA_1_1.value;
                if (!defaultIsEqualCustomizer(valueObj[key], otherObj[key])) {
                    return false;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (keysA_1_1 && !keysA_1_1.done && (_a = keysA_1.return)) _a.call(keysA_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return true;
    }
}
exports.isEqual = isEqual;
// Performs a deep comparison between two values using a customizer function
function isEqualWith(value, other, customizer) {
    if (value === other) {
        return true;
    }
    return customizer(value, other);
}
exports.isEqualWith = isEqualWith;
// Checks if `value` is an Error object
function isError(value) {
    return value instanceof Error;
}
exports.isError = isError;
// Checks if `value` is a finite number
function isFinite(value) {
    return Number.isFinite(value);
}
exports.isFinite = isFinite;
// Checks if `value` is a function
function isFunction(value) {
    return typeof value === "function";
}
exports.isFunction = isFunction;
// Checks if `value` is an integer
function isInteger(value) {
    return Number.isInteger(value);
}
exports.isInteger = isInteger;
// Checks if `value` is a valid array-like length
function isLength(value) {
    return isInteger(value) && value >= 0;
}
exports.isLength = isLength;
// Checks if `value` is a Map object
function isMap(value) {
    return value instanceof Map;
}
exports.isMap = isMap;
// Checks if `value` matches the properties and values of `source`
function isMatch(object, source) {
    return Object.keys(source).every(function (key) {
        return isEqual(object[key], source[key]);
    });
}
exports.isMatch = isMatch;
// Checks if `value` matches the properties and values of `source` using a customizer function
function isMatchWith(object, source, customizer) {
    return Object.keys(source).every(function (key) {
        return customizer(object[key], source[key]);
    });
}
exports.isMatchWith = isMatchWith;
// Checks if `value` is NaN
function isNaN(value) {
    return Number.isNaN(value);
}
exports.isNaN = isNaN;
// Checks if `value` is a native function
function isNative(value) {
    return typeof value === "function" && /native code/.test(value.toString());
}
exports.isNative = isNative;
// Checks if `value` is null or undefined
function isNil(value) {
    return value == null;
}
exports.isNil = isNil;
// Checks if `value` is null
function isNull(value) {
    return value === null;
}
exports.isNull = isNull;
// Checks if `value` is an object (excluding null)
function isObject(value) {
    return typeof value === "object" && value !== null;
}
exports.isObject = isObject;
// Checks if `value` is an object-like (has a value of type object and is not null)
function isObjectLike(value) {
    return typeof value === "object" && value === null;
}
exports.isObjectLike = isObjectLike;
// Checks if `value` is a plain object (created by the Object constructor or literal notation)
function isPlainObject(value) {
    if (!isObjectLike(value) ||
        Object.prototype.toString.call(value) !== "[object Object]") {
        return false;
    }
    if (Object.getPrototypeOf(value) === null) {
        return true;
    }
    var proto = value;
    while (Object.getPrototypeOf(proto) !== null) {
        proto = Object.getPrototypeOf(proto);
    }
    return Object.getPrototypeOf(value) === proto;
}
exports.isPlainObject = isPlainObject;
// Checks if `value` is a RegExp object
function isRegExp(value) {
    return value instanceof RegExp;
}
exports.isRegExp = isRegExp;
// Checks if `value` is a safe integer
function isSafeInteger(value) {
    return Number.isSafeInteger(value);
}
exports.isSafeInteger = isSafeInteger;
// Checks if `value` is a Set object
function isSet(value) {
    return value instanceof Set;
}
exports.isSet = isSet;
// Checks if `value` is a string
function isString(value) {
    return typeof value === "string";
}
exports.isString = isString;
// Checks if `value` is a Symbol
function isSymbol(value) {
    return typeof value === "symbol";
}
exports.isSymbol = isSymbol;
// Checks if `value` is an undefined value
function isUndefined(value) {
    return value === undefined;
}
exports.isUndefined = isUndefined;
// Checks if `value` is a weak Map object
function isWeakMap(value) {
    return value instanceof WeakMap;
}
exports.isWeakMap = isWeakMap;
// Checks if `value` is a weak Set object
function isWeakSet(value) {
    return value instanceof WeakSet;
}
exports.isWeakSet = isWeakSet;
// Checks if `value` is less than `other`
function lt(value, other) {
    return value < other;
}
exports.lt = lt;
// Checks if `value` is less than or equal to `other`
function lte(value, other) {
    return value <= other;
}
exports.lte = lte;
// Converts `value` to an array
function toArray(value) {
    if (Array.isArray(value)) {
        return value;
    }
    if (isIterable(value)) {
        return Array.from(value);
    }
    return [value];
}
exports.toArray = toArray;
// Converts `value` to a finite number
function toFinite(value) {
    var parsedValue = Number(value);
    return Number.isFinite(parsedValue) ? parsedValue : 0;
}
exports.toFinite = toFinite;
// Converts `value` to an integer
function toInteger(value) {
    var parsedValue = Number(value);
    return Number.isInteger(parsedValue) ? parsedValue : 0;
}
exports.toInteger = toInteger;
// Converts `value` to a safe integer
function toSafeInteger(value) {
    var parsedValue = Number(value);
    if (Number.isSafeInteger(parsedValue)) {
        return parsedValue;
    }
    if (parsedValue < Number.MIN_SAFE_INTEGER) {
        return Number.MIN_SAFE_INTEGER;
    }
    if (parsedValue > Number.MAX_SAFE_INTEGER) {
        return Number.MAX_SAFE_INTEGER;
    }
    return 0;
}
exports.toSafeInteger = toSafeInteger;
// Converts `value` to a string
function toString(value) {
    if (value == null) {
        return "";
    }
    if (typeof value === "string") {
        return value;
    }
    return String(value);
}
exports.toString = toString;
/**
 * Checks if a value is iterable.
 * @param value The value to check.
 * @returns Returns `true` if the value is iterable, `false` otherwise.
 */
function isIterable(value) {
    return (typeof value === "object" && value !== null && Symbol.iterator in value);
}
exports.isIterable = isIterable;
/**
 * Safely converts a JavaScript value to a JSON string, handling circular references.
 * @param value - The value to be converted to a JSON string.
 * @param replacer - Optional. A function that alters the behavior of the stringification process.
 * @param space - Optional. The number of spaces to use for indentation or a string used for indentation.
 * @returns A JSON string representing the input value.
 */
function safeStringify(value, replacer, space) {
    var seen = new WeakSet();
    /**
     * Default replacer function used when a custom replacer is not provided.
     * @param key - The current key being processed.
     * @param val - The value corresponding to the current key.
     * @returns The value to be stringified.
     */
    var defaultReplacer = function (key, val) {
        if (typeof val === "object" && val !== null) {
            if (seen.has(val)) {
                return "[Circular Reference]";
            }
            seen.add(val);
        }
        return val;
    };
    try {
        return JSON.stringify(value, replacer || defaultReplacer, space);
    }
    catch (error) {
        console.error("Error while stringifying:", error);
        return "";
    }
}
exports.safeStringify = safeStringify;
// Converts `value` to a number
function toNumber(value) {
    if (typeof value === "number") {
        return value;
    }
    if (typeof value === "string") {
        var parsedValue = parseFloat(value);
        return isNaN(parsedValue) ? 0 : parsedValue;
    }
    return 0;
}
exports.toNumber = toNumber;
// Converts `value` to a plain object
function toPlainObject(value) {
    if (typeof value !== "object" || value === null) {
        return {};
    }
    return __assign({}, value);
}
exports.toPlainObject = toPlainObject;
function isNumber(val) {
    return typeof val === "number" && !isNaN(val);
}
exports.isNumber = isNumber;
function isStringArray(val) {
    return Array.isArray(val) && val.every(isString);
}
exports.isStringArray = isStringArray;
function isNumberArray(val) {
    return Array.isArray(val) && val.every(isNumber);
}
exports.isNumberArray = isNumberArray;
function isDate(val) {
    return (val &&
        Object.prototype.toString.call(val) === "[object Date]" &&
        !isNaN(val));
}
exports.isDate = isDate;
function isPromise(val) {
    return val instanceof Promise;
}
exports.isPromise = isPromise;
function isBigInt(val) {
    return typeof val === "bigint";
}
exports.isBigInt = isBigInt;
function isNumeric(n) {
    return !isNaN(parseFloat(n)) && isFinite(n);
}
exports.isNumeric = isNumeric;
function isEmptyObject(obj) {
    return Object.keys(obj).length === 0;
}
exports.isEmptyObject = isEmptyObject;
function isWindow(obj) {
    return (obj !== null &&
        typeof obj === "object" &&
        obj === obj.window);
}
exports.isWindow = isWindow;
function type(obj) {
    return Object.prototype.toString.call(obj).slice(8, -1).toLowerCase();
}
exports.type = type;
function isTypedArray(val) {
    return (val instanceof Int8Array ||
        val instanceof Uint8Array ||
        val instanceof Uint8ClampedArray ||
        val instanceof Int16Array ||
        val instanceof Uint16Array ||
        val instanceof Int32Array ||
        val instanceof Uint32Array ||
        val instanceof Float32Array ||
        val instanceof Float64Array);
}
exports.isTypedArray = isTypedArray;
function isReadonlyArray(val) {
    return Array.isArray(val) && Object.isFrozen(val);
}
exports.isReadonlyArray = isReadonlyArray;
function hasSameType(val, type) {
    return val === type;
}
exports.hasSameType = hasSameType;
function isObjectEmpty(obj) {
    return isObject(obj) && Object.keys(obj).length === 0;
}
exports.isObjectEmpty = isObjectEmpty;
function isLiteral(val, type) {
    return val === type;
}
exports.isLiteral = isLiteral;
function isUnion(val, types) {
    return types.some(function (t) {
        return typeof t === "function" &&
            val instanceof t;
    });
}
exports.isUnion = isUnion;
function isExactUnion(val, types) {
    return types.some(function (t) { return hasSameType(val, t); });
}
exports.isExactUnion = isExactUnion;
function isPromiseOfT(obj) {
    return (!!obj &&
        (typeof obj === "object" || typeof obj === "function") &&
        typeof obj.then === "function");
}
exports.isPromiseOfT = isPromiseOfT;
//# sourceMappingURL=type-utilities.js.map