/**
 * Converts a base64-encoded string to a Blob object.
 * @param {string} base64 - The base64-encoded string representing the data.
 * @returns {Blob} The Blob object created from the base64 data.
 * @example
 * // Example usage:
 * const base64Data = "data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAMgA...";
 * const blob = base64ToBlob(base64Data);
 * console.log(blob); // Blob { ... }
 */
declare function base64ToBlob(base64: string): Blob;
export { base64ToBlob };
//# sourceMappingURL=blob-utilities.d.ts.map