declare function findParent(element: Element | null, condition: (el: Element) => boolean): Element | null;
declare function findChild(element: Element | null, condition: (element: Element) => boolean): Element | null;
declare function getParentsRecursively(element: Element | null): Element[];
declare function getChildrenRecursively(element: Element | null): Element[];
declare function getNParentsRecursively(element: Element | null, n: number): Element[];
declare function getNChildrenRecursively(element: Element | null, n: number): Element[];
declare function getSiblings(element: Element, siblingType?: "both" | "next" | "prev"): Element[];
declare function findSiblings(element: Element, condition: (element: Element) => boolean, siblingType?: "both" | "next" | "prev"): Element[];
declare function simplifyHTML(htmlString: string): string;
declare function simplifyHTMLWithRegex(htmlString: string): string;
declare function replaceAllElements(htmlString: string, newElement: string): string;
declare function replaceElementName(htmlString: string, oldElement: string, newElement: string): string;
declare function removeChildren(parentElement: Element): void;
declare function addClassToAll(selector: string, className: string): void;
declare function addClassesToAll(selector: string, ...classNames: string[]): void;
declare function css(selector: string, propertyName: string, value: string): HTMLElement | null;
declare function attr(selector: string, attribute: string, value: string): HTMLElement | null;
declare function removeAttr(selector: string, attribute: string): HTMLElement | null;
declare function hasClass(selector: string, className: string): boolean;
declare function addClass(selector: string, className: string): HTMLElement | null;
declare function addClasses(selector: string, ...classNames: string[]): HTMLElement | null;
declare function removeClass(selector: string, className: string): HTMLElement | null;
declare function removeClasses(selector: string, ...classNames: string[]): HTMLElement | null;
declare function toggleClass(selector: string, className: string): HTMLElement | null;
declare function offsetOf(el: HTMLElement): {
    left: number;
    top: number;
};
declare function offset(selector: string): {
    left: number;
    top: number;
} | null;
declare function parent(selector: string): HTMLElement | null;
declare function parentNode(selector: string): ParentNode | null;
declare function dataOf(element: HTMLElement, key: string, value?: unknown): string | undefined;
declare function data(selector: string, key: string, value?: unknown): null | string | undefined;
declare function positionOf(el: HTMLElement): {
    left: number;
    top: number;
};
declare function position(selector: string): {
    left: number;
    top: number;
} | null;
declare function scrollTopOf(el: HTMLElement, value?: number): HTMLElement | number;
declare function scrollLeftOf(el: HTMLElement, value?: number): HTMLElement | number;
declare function scrollTop(selector: string, value?: number): HTMLElement | null | number;
declare function scrollLeft(selector: string, value?: number): HTMLElement | null | number;
declare function heightOf(el: HTMLElement, value?: string): HTMLElement | number;
declare function height(selector: string, value?: string): HTMLElement | null | number;
declare function removeOf(el: HTMLElement): void;
declare function removeBy(selector: string): void;
declare function emptyOf(el: HTMLElement): HTMLElement;
declare function empty(selector: string): HTMLElement | null;
declare function cloneOf(el: HTMLElement): HTMLElement;
declare function cloneBy(selector: string): HTMLElement | null;
declare function htmlOf(el: HTMLElement, value?: string): HTMLElement | string;
declare function textOf(el: HTMLElement, value?: string): HTMLElement | null | string;
declare function html(selector: string, value?: string): HTMLElement | null | string;
declare function text(selector: string, value?: string): HTMLElement | null | string;
declare function append(el: HTMLElement, child: HTMLElement): HTMLElement;
declare function prepend(el: HTMLElement, child: HTMLElement): HTMLElement;
declare function afterHTMLElement(el: HTMLElement, sibling: HTMLElement): void;
declare function beforeHTMLElement(el: HTMLElement, sibling: HTMLElement): void;
declare function replaceWith(el: HTMLElement, newEl: HTMLElement): void;
declare function appendTo(el: HTMLElement, parent: HTMLElement): HTMLElement;
declare function prependTo(el: HTMLElement, parent: HTMLElement): HTMLElement;
declare function insertAfter(el: HTMLElement, refEl: HTMLElement): void;
declare function insertBefore(el: HTMLElement, refEl: HTMLElement): void;
declare function replaceAll(el: HTMLElement, selector: string): void;
declare function findHTMLElement(el: HTMLElement, selector: string): NodeListOf<Element>;
declare function filterHTMLElement(els: HTMLElement[], filterFn: (el: HTMLElement) => boolean): HTMLElement[];
declare function hasHTMLElement(el: HTMLElement, selector: string): boolean;
declare function not(els: HTMLElement[], filterFn: (el: HTMLElement) => boolean): HTMLElement[];
declare function is(el: HTMLElement, selector: string): boolean;
declare function addHTMLElement(el: HTMLElement, ...elements: HTMLElement[]): HTMLElement[];
declare function contents(el: HTMLElement): Node[];
declare function closest(el: HTMLElement, selector: string): Element | null;
declare function parents(el: HTMLElement, selector?: string): Element[];
declare function parentOf(el: HTMLElement): Element | null;
declare function children(el: HTMLElement, selector?: string): Element[];
declare function siblings(el: HTMLElement, selector?: string): Element[];
declare function prevHTMLElement(el: HTMLElement): Element | null;
declare function nextHTMLElement(el: HTMLElement): Element | null;
declare function index(el: HTMLElement): number;
declare function wrapHTMLElement(el: HTMLElement, wrapper: HTMLElement): void;
declare function wrapAll(els: HTMLElement[], wrapper: HTMLElement): void;
declare function wrapInner(el: HTMLElement, wrapper: HTMLElement): void;
declare function unwrap(el: HTMLElement): void;
declare function val(el: HTMLInputElement | HTMLSelectElement | HTMLTextAreaElement, value?: string): HTMLElement | string;
declare function on(el: HTMLElement, event: string, handler: (ev: Event) => void): HTMLElement;
declare function off(el: HTMLElement, event: string, handler: (ev: Event) => void): HTMLElement;
declare function contains(container: Node, contained: Node): boolean;
declare function one(el: HTMLElement, event: string, handler: (ev: Event) => void): HTMLElement;
declare function trigger(el: HTMLElement, event: string): HTMLElement;
declare function show(el: HTMLElement): HTMLElement;
declare function hide(el: HTMLElement): HTMLElement;
declare function toggle(el: HTMLElement): HTMLElement;
declare function $(selector: string): Element | null;
declare function $$(selector: string): NodeListOf<Element>;
export { $, $$, addClass, addClassToAll, addClasses, addClassesToAll, addHTMLElement, afterHTMLElement, append, appendTo, attr, beforeHTMLElement, children, cloneBy, cloneOf, closest, contains, contents, css, data, dataOf, empty, emptyOf, filterHTMLElement, findChild, findHTMLElement, findParent, findSiblings, getChildrenRecursively, getNChildrenRecursively, getNParentsRecursively, getParentsRecursively, getSiblings, hasClass, hasHTMLElement, height, heightOf, hide, html, htmlOf, index, insertAfter, insertBefore, is, nextHTMLElement, not, off, offset, offsetOf, on, one, parent, parentNode, parentOf, parents, position, positionOf, prepend, prependTo, prevHTMLElement, removeAttr, removeBy, removeChildren, removeClass, removeClasses, removeOf, replaceAll, replaceAllElements, replaceElementName, replaceWith, scrollLeft, scrollLeftOf, scrollTop, scrollTopOf, show, siblings, simplifyHTML, simplifyHTMLWithRegex, text, textOf, toggle, toggleClass, trigger, unwrap, val, wrapAll, wrapHTMLElement, wrapInner, };
//# sourceMappingURL=dom-utilities.d.ts.map