/* eslint-disable @typescript-eslint/ban-types */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/**
 * Creates a function that accepts up to `n` arguments, ignoring unknown additional arguments.
 */
function ary(func, n) {
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return func.apply(void 0, __spreadArray([], __read(args.slice(0, n)), false));
    };
}
/**
 * Creates a function that invokes `func` only before the specified `n` calls.
 */
function before(n, func) {
    var count = 0;
    var result;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (count < n) {
            count++;
            result = func.apply(this, args);
        }
        return result;
    };
}
/**
 * Creates a function that invokes `func` with the `this` binding of `thisArg` and prepends unknown additional supplied arguments.
 */
function bind(func, thisArg) {
    var partials = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        partials[_i - 2] = arguments[_i];
    }
    return func.bind.apply(func, __spreadArray([thisArg], __read(partials), false));
}
/**
 * Creates a function that invokes the method at `object[key]` with the `this` binding of `object` and prepends unknown additional supplied arguments.
 */
function bindKey(object, key) {
    var partials = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        partials[_i - 2] = arguments[_i];
    }
    var func = object[key];
    if (typeof func !== "function") {
        throw new Error("Expected a function");
    }
    return func.bind.apply(func, __spreadArray([object], __read(partials), false));
}
/**
 * Creates a curried function that invokes `func` with arguments provided one at a time.
 */
function curry(func, arity) {
    if (arity === void 0) { arity = func.length; }
    return function curried() {
        var _this = this;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (args.length >= arity) {
            return func.apply(this, args);
        }
        return function () {
            var nextArgs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                nextArgs[_i] = arguments[_i];
            }
            return curried.apply(_this, args.concat(nextArgs));
        };
    };
}
/**
 * Creates a curried function that invokes `func` with arguments provided in reverse order.
 */
function curryRight(func, arity) {
    if (arity === void 0) { arity = func.length; }
    return function curried() {
        var _this = this;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (args.length >= arity) {
            return func.apply(this, args);
        }
        return function () {
            var nextArgs = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                nextArgs[_i] = arguments[_i];
            }
            return curried.apply(_this, nextArgs.concat(args));
        };
    };
}
/**
 * Creates a debounced function that delays invoking `func` until after `wait` milliseconds have elapsed since the last time the debounced function was invoked.
 */
function debounce(func, wait) {
    if (wait === void 0) { wait = 0; }
    var timeout;
    return function debounced() {
        var _this = this;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        clearTimeout(timeout);
        timeout = setTimeout(function () {
            func.apply(_this, args);
        }, wait);
    };
}
/**
 * Defers invoking the `func` until the current call stack has cleared.
 */
function defer(func) {
    setTimeout(func, 0);
}
/**
 * Invokes `func` after `wait` milliseconds.
 */
function delay(func, wait) {
    if (wait === void 0) { wait = 0; }
    var args = [];
    for (var _i = 2; _i < arguments.length; _i++) {
        args[_i - 2] = arguments[_i];
    }
    setTimeout(function () {
        func.apply(void 0, __spreadArray([], __read(args), false));
    }, wait);
}
/**
 * Creates a function that invokes `func` with arguments reversed.
 */
function flip(func) {
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return func.apply(this, args.reverse());
    };
}
/**
 * Creates a memoized function that caches the result of `func` for the given argument.
 */
function memoize(func) {
    var cache = {};
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var key = JSON.stringify(args);
        if (cache[key] === undefined) {
            cache[key] = func.apply(this, args);
        }
        return cache[key];
    };
}
/**
 * Creates a negated version of `predicate` function.
 */
function negate(predicate) {
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return !predicate.apply(this, args);
    };
}
/**
 * Creates a function that invokes `func` only once. Subsequent calls to the returned function will return the result of the first call.
 */
function once(func) {
    var result;
    var executed = false;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (!executed) {
            result = func.apply(this, args);
            executed = true;
        }
        return result;
    };
}
/**
 * Creates a function that invokes `func` with arguments transformed by corresponding `transforms`.
 */
function overArgs(func, transforms) {
    return function () {
        var _this = this;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var transformedArgs = args.map(function (arg, index) { var _a, _b; return (_b = (_a = transforms[index]) === null || _a === void 0 ? void 0 : _a.call(_this, arg)) !== null && _b !== void 0 ? _b : arg; });
        return func.apply(this, transformedArgs);
    };
}
/**
 * Creates a partially applied function by filling in `partials` argument placeholders.
 */
function partial(func) {
    var partials = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        partials[_i - 1] = arguments[_i];
    }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var combinedArgs = partials.map(function (partial) {
            return partial === undefined ? args.shift() : partial;
        });
        return func.apply(this, combinedArgs.concat(args));
    };
}
/**
 * Creates a partially applied function by filling in `partials` argument placeholders from the right.
 */
function partialRight(func) {
    var partials = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        partials[_i - 1] = arguments[_i];
    }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var combinedArgs = partials
            .reverse()
            .map(function (partial) { return (partial === undefined ? args.pop() : partial); })
            .reverse();
        return func.apply(this, combinedArgs.concat(args));
    };
}
/**
 * Creates a function that invokes `func` with arguments rearranged according to the specified `indexes`.
 */
function rearg(func, indexes) {
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var rearrangedArgs = indexes.map(function (index) { return args[index]; });
        return func.apply(this, rearrangedArgs);
    };
}
/**
 * Creates a function that invokes `func` with the rest arguments it receives.
 */
function rest(func, start) {
    if (start === void 0) { start = func.length - 1; }
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var restArgs = args.slice(start);
        var initialArgs = args.slice(0, start);
        return func.apply(this, __spreadArray([initialArgs], __read(restArgs), false));
    };
}
/**
 * Creates a function that invokes `func` with an array of arguments, spreading them out.
 */
function spread(func) {
    return function (argsArray) {
        return func.apply(this, argsArray);
    };
}
/**
 * Creates a throttled function that invokes `func` at most once per every `wait` milliseconds.
 */
function throttle(func, wait) {
    if (wait === void 0) { wait = 0; }
    var timeout = null;
    var previous = 0;
    return function throttled() {
        var _this = this;
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var now = Date.now();
        var remaining = wait - (now - previous);
        if (remaining <= 0) {
            if (timeout) {
                clearTimeout(timeout);
                timeout = null;
            }
            previous = now;
            func.apply(this, args);
        }
        else if (!timeout) {
            timeout = setTimeout(function () {
                previous = Date.now();
                timeout = null;
                func.apply(_this, args);
            }, remaining);
        }
    };
}
/**
 * Creates a function that accepts only one argument, discarding unknown additional arguments.
 */
function unary(func) {
    return function (arg) {
        return func.call(this, arg);
    };
}
/**
 * Wraps `func` to enable currying.
 */
function wrap(func, wrapper) {
    return curry(wrapper, func.length)(func);
}
/**
 * Invokes `func` when it is called `n` or more times.
 */
function after(n, func) {
    var count = 0;
    return function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        count++;
        if (count >= n) {
            return func.apply(this, args);
        }
    };
}
/**
 * Creates a pipeline of synchronous unary functions and returns a new function.
 * When the returned function is called with an argument, it passes that argument
 * through each function in the pipeline, starting with the first function, and
 * returns the final result.
 *
 * @param first The first function to apply in the pipeline.
 * @param fns The rest of the functions to apply in the pipeline.
 * @returns A new function that applies the pipeline to its argument.
 */
function pipe(first) {
    var fns = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        fns[_i - 1] = arguments[_i];
    }
    return function (initial) {
        return fns.reduce(function (prev, fn) { return fn(prev); }, first(initial));
    };
}
/**
 * Similar to the `pipe` function, but designed for asynchronous unary functions.
 * It creates a pipeline of asynchronous functions and returns a new function.
 * When the returned function is called with an argument, it asynchronously
 * passes that argument through each function in the pipeline, awaiting each
 * function before applying the next one, and returns a Promise of the final result.
 *
 * @param first The first async function to apply in the pipeline.
 * @param fns The rest of the async functions to apply in the pipeline.
 * @returns A new function that applies the pipeline to its argument.
 */
function pipeAsync(first) {
    var fns = [];
    for (var _i = 1; _i < arguments.length; _i++) {
        fns[_i - 1] = arguments[_i];
    }
    return function (initial) {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fns.reduce(function (prev, fn) { return __awaiter(_this, void 0, void 0, function () { var _a; return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    _a = fn;
                                    return [4 /*yield*/, prev];
                                case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
                            }
                        }); }); }, first(initial))];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
}
/**
 * Composes multiple functions into a single function that applies them in right-to-left order.
 *
 * @template T - The type of the input and output values.
 * @param {...((input: T) => T)[]} fns - The functions to compose.
 * @returns {(input: T) => T} A function that applies the composed functions to the input value.
 */
function compose() {
    var fns = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        fns[_i] = arguments[_i];
    }
    return function (input) { return fns.reduceRight(function (acc, fn) { return fn(acc); }, input); };
}
export { after, ary, before, bind, bindKey, compose, curry, curryRight, debounce, defer, delay, flip, memoize, negate, once, overArgs, partial, partialRight, pipe, pipeAsync, rearg, rest, spread, throttle, unary, wrap, };
//# sourceMappingURL=function-utilities.js.map